@ECHO OFF

ECHO +--------------------------------------------------+
ECHO ^|   IP2LOCATION AUTOMATED DATABASE UPDATE SCRIPT   ^|
ECHO ^|   ============================================   ^|
ECHO ^|        Website: http://www.ip2location.com       ^|
ECHO ^|        Contact: support@ip2location.com          ^|
ECHO +--------------------------------------------------+

REM SET YOUR IP2LOCATION LOGIN DETAILS BELOW
SET TOKEN=DOWNLOAD_TOKEN
SET CODE=DB24BIN
SET OUTPUTNAME=mydata.zip
SET FINALFOLDER=C:\IP2Location

SET ROOT=%~dp0
IF NOT EXIST "%ROOT%tmp" MKDIR "%ROOT%tmp"
SET DOWNLOADFOLDER=%ROOT%tmp

REM DO NOT EDIT ANYTHING BELOW THIS LINE

IF NOT EXIST "%ROOT%download.ps1" GOTO DOWNLOADERMISSINGERROR
IF NOT EXIST "%ROOT%unzip.ps1" GOTO UNZIPMISSINGERROR

powershell -Command "set-executionpolicy unrestricted"

ECHO Downloading latest database from IP2Location website.

powershell -File download.ps1 %TOKEN% %CODE% %OUTPUTNAME% %DOWNLOADFOLDER%

ECHO | SET /p=Download.............................................. 

IF NOT EXIST "%DOWNLOADFOLDER%\%OUTPUTNAME%" GOTO ERROR

FOR %%A IN ("%DOWNLOADFOLDER%\%OUTPUTNAME%") DO SET SIZE=%%~zA

IF %SIZE% LSS 102400 GOTO ERROR

ECHO [OK]

ECHO | SET /p=Decompressing package................................. 

powershell -File unzip.ps1 %OUTPUTNAME% %DOWNLOADFOLDER%

IF NOT EXIST "%DOWNLOADFOLDER%\*.BIN" GOTO ERROR

ECHO [OK]

CD %DOWNLOADFOLDER%

FOR %%c IN (*.BIN) DO SET NAME=%%c

COPY /Y %NAME% %FINALFOLDER%

ECHO | SET /p=Performing final clean up............................. 

CD %ROOT%
RMDIR /s /q %DOWNLOADFOLDER% 

ECHO [OK]

GOTO DONE

:ERROR
ECHO [ERROR]
GOTO:EOF

:DOWNLOADERMISSINGERROR
ECHO ERROR: Missing download.ps1 file.
GOTO:EOF

:UNZIPMISSINGERROR
ECHO ERROR: Missing unzip.ps1 file.
GOTO:EOF

:MYSQLERROR
ECHO [ERROR] Please make sure your MySQL settings are correct.
GOTO:EOF

:DONE
ECHO ... [ALL DONE] ...
GOTO:EOF 